class TornException(Exception):
    ERROR_DESCRIPTIONS = {
        '0': 'Unhandled error, should not occur.',
        '1': 'Private key is empty in current request.',
        '2': 'Private key is wrong/incorrect format.',
        '3': 'Requesting an incorrect basic type.',
        '4': 'Requesting incorrect selection fields.',
        '5': 'Current private key is banned for a small period of time because'
             'of too many requests (max 100/min).',
        '6': 'Wrong ID value.',
        '7': 'A requested selection is private (For example, personal data of'
             'another user/faction).',
        '8': 'Current IP is banned for a small period of time because of abuse.',
    }

    def __init__(self, err_dict):
        self.error_code = err_dict['code']
        self.error_type = err_dict['error']
        self.error_description = self.ERROR_DESCRIPTIONS[str(self.error_code)]

    def __str__(self):
        return '{} ({}): {}'.format(self.error_type, self.error_code,
                                    self.error_description)
